package com.example

import io.grpc.examples.helloworld.GreeterGrpcKt
import io.grpc.examples.helloworld.HelloReply
import io.grpc.examples.helloworld.HelloRequest
import net.devh.boot.grpc.server.service.GrpcService
import org.slf4j.Logger
import org.slf4j.LoggerFactory

@GrpcService(interceptors = [OtelContextPropagatingServerInterceptor::class])
class GreeterImpl : GreeterGrpcKt.GreeterCoroutineImplBase() {
    private val LOG: Logger = LoggerFactory.getLogger(GreeterImpl::class.java)

    override suspend fun sayHello(request: HelloRequest): HelloReply {
        LOG.debug("Hello {}", request.name)
        return HelloReply.newBuilder().setMessage("Hello ${request.name}").build()
    }
}