package com.example

import io.grpc.Metadata
import io.grpc.ServerCall
import io.grpc.kotlin.CoroutineContextServerInterceptor
import io.opentelemetry.context.Context
import io.opentelemetry.extension.kotlin.asContextElement
import org.springframework.core.Ordered
import org.springframework.core.annotation.Order
import kotlin.coroutines.CoroutineContext

@Order(Ordered.LOWEST_PRECEDENCE)
class OtelContextPropagatingServerInterceptor : CoroutineContextServerInterceptor() {
    override fun coroutineContext(call: ServerCall<*, *>, headers: Metadata): CoroutineContext {
        return Context.current().asContextElement()
    }
}